{#-#####################################################################
 #
 # Echoes the full path to the device file representing a storage volume
 # on the configured system.
 #
 # This template accepts a storage volume definition and applies
 # platform-specific rules to build a deterministic path to the
 # device file representing this storage volume.
 #
 #======================================================================
 # Parameters
 #======================================================================
 # This template must be invoked with on the following parameters:
 #
 #  - storage_volume (fr.pep06.schemas.storage.volume):
 #      A valid instance of the storage.volume data type.
 ####################################################################-#}
{#-=====================================================================
 # Echoes the definition of the parent storage volume as a JSON string.
 #===================================================================-#}
{%- macro get_parent_volume(storage_volume_uid) -%}
  {{ my_storage_volumes
    | selectattr('uid', 'equalto', storage_volume_uid)
    | list
    | first
    | to_json
  }}
{%- endmacro -%}

{#-=====================================================================
 # Echoes the full path to the device of a storage volume as a string.
 # ---------------------------------------------------------------------
 # Parameters
 # ---------------------------------------------------------------------
 #  storage_volume (fr.pep06.schemas.storage.volume)
 #    The storage volume definition to process
 #
 #  raw (bool)
 #    Whether to return the raw device name of the storage volume, if
 #    available. Raw device names live directly under /dev.
 #===================================================================-#}
{%- macro get_storage_volume_device(storage_volume, raw=false) -%}
  {#--------------------------------------------------------------------
   # Output the device name of a storage disk
   #------------------------------------------------------------------#}
  {%- if storage_volume['type'] == 'disk' -%}

    {%- set id_value = storage_volume['disk']['identifier']['value'] -%}
    {%- set id_class = storage_volume['disk']['identifier']['class'] -%}

    {#- Linux-style paths -#}
    {%-   if ansible_system == 'Linux' -%}
      {%-   if id_class == 'id' -%}
        {%- set device_path = '/dev/disk/by-id/' ~ id_value -%}
      {%- elif id_class == 'dev' -%}
        {%- set device_path = '/dev/' ~ id_value -%}
      {%- elif id_class == 'path' -%}
        {%- set device_path = '/dev/by-path/' ~ id_value -%}
      {%- elif id_class == 'uuid' -%}
        {%- set device_path = '/dev/by-uuid/' ~ id_value -%}
      {%- endif -%}

      {%- if raw and id_class != 'dev' -%}
        {{ lookup('pipe', 'readlink -f ' ~ device_path) }}
      {%- else -%}
        {{ device_path }}
      {%- endif -%}
    
    {#- FreeBSD-style paths -#}
    {%- elif ansible_system == 'FreeBSD' -%}
      {%- if id_class == 'dev' -%}
        {%- set device_path = '/dev/' ~ id_value -%}
      {%- endif -%}
      {{ device_path }}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # Output the device name of a storage partition
   #------------------------------------------------------------------#}
  {%- elif storage_volume['type'] == 'partition' -%}
    {%- set parent_volume_uid =
          storage_volume['partition']['parent'] -%}
    {%- set parent_volume =
          get_parent_volume(parent_volume_uid) | from_json -%}
    {%- set parent_volume_device =
          get_storage_volume_device(parent_volume, raw=true) -%}

    {#- If GPT label are used, build a symbolic path with GPT labels -#}
    {%- if  raw == false
        and 'scheme' in parent_volume
        and parent_volume['scheme'] == 'gpt'
        and 'label' in storage_volume
    -%}
      {%-   if ansible_system == 'Linux' -%}
        {{ '/dev/disk/by-partlabel/' ~ storage_volume['label'] }}

      {%- elif ansible_system == 'FreeBSD' -%}
         {{ '/dev/gpt/' ~ storage_volume['label'] }}
      {%- endif -%}

    {#- Else, fallback to raw device names -#}
    {%- else -%}

      {%- if 'index' in storage_volume['partition'] -%}
        {%- set partition_index =
              storage_volume['partition']['index'] -%}
      {%- else -%}
        {%- set partition_index = 0 -%}
      {%- endif -%} 

      {%- if ansible_system == 'Linux' -%}
        {{ parent_volume_device ~ (partition_index | int + 1) }}
      {%- elif ansible_system == 'FreeBSD' -%}
        {{ parent_volume_device ~ 'p' ~ partition_index }}
      {%- endif -%}
    {%- endif -%}
    
  {#--------------------------------------------------------------------
   # Output the device name of an encrypted partition
   #------------------------------------------------------------------#}
  {%- elif storage_volume['type'] == 'encrypted' -%}
    {%- set parent_volume_uid =
          storage_volume['encrypted']['parent'] -%}
    {%- set parent_volume =
          get_parent_volume(parent_volume_uid) | from_json -%}
    {%- set parent_volume_device =
          get_storage_volume_device(parent_volume, raw=true) -%}

    {#- Encrypted volumes cannot have a raw device name -#}
    {%- if not raw -%}

      {#- Assume LUKS on Linux platforms -#}
      {%- if ansible_system == 'Linux' -%}
        {%- if 'label' in storage_volume -%}
          {{ '/dev/mapper/' ~ storage_volume['label'] }}
        {%- else -%}
          {{ '/dev/mapper/' ~ storage_volume['uid'] }}
        {%- endif -%}

      {#- Assume GELI on FreeBSD platforms -#}
      {%- elif ansible_system == 'FreeBSD' -%}
        {{ parent_volume_device ~ '.eli' }}
      {%- endif -%}
    {%- endif -%}
  {%- endif -%}
{%- endmacro -%}

{{ get_storage_volume_device(storage_volume) }}